<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomTextOptionsDataList StructType
 * @subpackage Structs
 */
class CustomTextOptionsDataList extends AbstractStructBase
{
    /**
     * The customTextOptionValue
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\CustomTextOptionsData[]
     */
    public $customTextOptionValue;
    /**
     * Constructor method for CustomTextOptionsDataList
     * @uses CustomTextOptionsDataList::setCustomTextOptionValue()
     * @param \StructType\CustomTextOptionsData[] $customTextOptionValue
     */
    public function __construct(array $customTextOptionValue = array())
    {
        $this
            ->setCustomTextOptionValue($customTextOptionValue);
    }
    /**
     * Get customTextOptionValue value
     * @return \StructType\CustomTextOptionsData[]|null
     */
    public function getCustomTextOptionValue()
    {
        return $this->customTextOptionValue;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomTextOptionValue method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomTextOptionValue method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomTextOptionValueForArrayConstraintsFromSetCustomTextOptionValue(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customTextOptionsDataListCustomTextOptionValueItem) {
            // validation for constraint: itemType
            if (!$customTextOptionsDataListCustomTextOptionValueItem instanceof \StructType\CustomTextOptionsData) {
                $invalidValues[] = is_object($customTextOptionsDataListCustomTextOptionValueItem) ? get_class($customTextOptionsDataListCustomTextOptionValueItem) : sprintf('%s(%s)', gettype($customTextOptionsDataListCustomTextOptionValueItem), var_export($customTextOptionsDataListCustomTextOptionValueItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customTextOptionValue property can only contain items of type \StructType\CustomTextOptionsData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customTextOptionValue value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomTextOptionsData[] $customTextOptionValue
     * @return \StructType\CustomTextOptionsDataList
     */
    public function setCustomTextOptionValue(array $customTextOptionValue = array())
    {
        // validation for constraint: array
        if ('' !== ($customTextOptionValueArrayErrorMessage = self::validateCustomTextOptionValueForArrayConstraintsFromSetCustomTextOptionValue($customTextOptionValue))) {
            throw new \InvalidArgumentException($customTextOptionValueArrayErrorMessage, __LINE__);
        }
        $this->customTextOptionValue = $customTextOptionValue;
        return $this;
    }
    /**
     * Add item to customTextOptionValue value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomTextOptionsData $item
     * @return \StructType\CustomTextOptionsDataList
     */
    public function addToCustomTextOptionValue(\StructType\CustomTextOptionsData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomTextOptionsData) {
            throw new \InvalidArgumentException(sprintf('The customTextOptionValue property can only contain items of type \StructType\CustomTextOptionsData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customTextOptionValue[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CustomTextOptionsDataList
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
